package de.cit.experiments;

import org.infinispan.Cache;
import org.infinispan.manager.DefaultCacheManager;

import java.io.IOException;
import java.io.InputStream;

public class Experiment {

    private static Experiment instance;

    private final DefaultCacheManager cacheManager;
    private Cache<Object, Object> cache;

    public Experiment(DefaultCacheManager cacheManager) {
        this.cacheManager = cacheManager;
    }

    public static Experiment getInstance() throws IOException {
        if (instance == null) {
            final InputStream resourceAsStream = Thread.currentThread().getContextClassLoader().getResourceAsStream("infinispan-test.xml");
            instance = new Experiment(new DefaultCacheManager(resourceAsStream));
        }
        return instance;
    }

    public void start() {
        cacheManager.start();
    }

    public void stop() {
        cacheManager.stop();
    }

    public Cache<Object, Object> getCache() {
        if (cache == null) {
            cache = cacheManager.getCache("EXP");
        }

        return cache;
    }

}
