package de.cit.experiments;

import org.infinispan.Cache;
import org.junit.*;

import java.io.IOException;
import java.util.UUID;

public class ExceptionTest {

    @BeforeClass
    public static void start() throws IOException {
        Experiment.getInstance().start();
    }

    @AfterClass
    public static void stop() throws IOException {
        Experiment.getInstance().stop();
    }

    @Test(expected = org.infinispan.commons.CacheException.class)
    public void nonSerializableItem() throws IOException {
            final Experiment instance = Experiment.getInstance();

            final Cache<Object, Object> cache = instance.getCache();

/*
            final TransactionManager transactionManager = cache.getAdvancedCache().getTransactionManager();
            transactionManager.begin();
*/


            final String key = UUID.randomUUID().toString();
            cache.put(key, new NonSerializableItem("test 1"));

/*
            transactionManager.commit();
*/


            final Object item = cache.get(key);

            System.out.println("item = " + item);
    }


    @Test(expected = org.infinispan.commons.CacheException.class)
    public void big() throws IOException {
        final Experiment instance = Experiment.getInstance();

        final Cache<Object, Object> cache = instance.getCache();

        final String key = UUID.randomUUID().toString();
        cache.put(key, "12345678901234567890");

        final Object item = cache.get(key);

        System.out.println("item = " + item);
    }

}
